// Code generated by go-swagger; DO NOT EDIT.

package namespaces

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCreateNamespaceParams creates a new CreateNamespaceParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateNamespaceParams() *CreateNamespaceParams {
	return &CreateNamespaceParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateNamespaceParamsWithTimeout creates a new CreateNamespaceParams object
// with the ability to set a timeout on a request.
func NewCreateNamespaceParamsWithTimeout(timeout time.Duration) *CreateNamespaceParams {
	return &CreateNamespaceParams{
		timeout: timeout,
	}
}

// NewCreateNamespaceParamsWithContext creates a new CreateNamespaceParams object
// with the ability to set a context for a request.
func NewCreateNamespaceParamsWithContext(ctx context.Context) *CreateNamespaceParams {
	return &CreateNamespaceParams{
		Context: ctx,
	}
}

// NewCreateNamespaceParamsWithHTTPClient creates a new CreateNamespaceParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateNamespaceParamsWithHTTPClient(client *http.Client) *CreateNamespaceParams {
	return &CreateNamespaceParams{
		HTTPClient: client,
	}
}

/* CreateNamespaceParams contains all the parameters to send to the API endpoint
   for the create namespace operation.

   Typically these are written to a http.Request.
*/
type CreateNamespaceParams struct {

	/* Namespace.

	   target namespace to create
	*/
	Namespace string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create namespace params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateNamespaceParams) WithDefaults() *CreateNamespaceParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create namespace params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateNamespaceParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create namespace params
func (o *CreateNamespaceParams) WithTimeout(timeout time.Duration) *CreateNamespaceParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create namespace params
func (o *CreateNamespaceParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create namespace params
func (o *CreateNamespaceParams) WithContext(ctx context.Context) *CreateNamespaceParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create namespace params
func (o *CreateNamespaceParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create namespace params
func (o *CreateNamespaceParams) WithHTTPClient(client *http.Client) *CreateNamespaceParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create namespace params
func (o *CreateNamespaceParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNamespace adds the namespace to the create namespace params
func (o *CreateNamespaceParams) WithNamespace(namespace string) *CreateNamespaceParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the create namespace params
func (o *CreateNamespaceParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WriteToRequest writes these params to a swagger request
func (o *CreateNamespaceParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
