// Code generated by go-swagger; DO NOT EDIT.

package node

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewDeleteNodeParams creates a new DeleteNodeParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewDeleteNodeParams() *DeleteNodeParams {
	return &DeleteNodeParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewDeleteNodeParamsWithTimeout creates a new DeleteNodeParams object
// with the ability to set a timeout on a request.
func NewDeleteNodeParamsWithTimeout(timeout time.Duration) *DeleteNodeParams {
	return &DeleteNodeParams{
		timeout: timeout,
	}
}

// NewDeleteNodeParamsWithContext creates a new DeleteNodeParams object
// with the ability to set a context for a request.
func NewDeleteNodeParamsWithContext(ctx context.Context) *DeleteNodeParams {
	return &DeleteNodeParams{
		Context: ctx,
	}
}

// NewDeleteNodeParamsWithHTTPClient creates a new DeleteNodeParams object
// with the ability to set a custom HTTPClient for a request.
func NewDeleteNodeParamsWithHTTPClient(client *http.Client) *DeleteNodeParams {
	return &DeleteNodeParams{
		HTTPClient: client,
	}
}

/* DeleteNodeParams contains all the parameters to send to the API endpoint
   for the delete node operation.

   Typically these are written to a http.Request.
*/
type DeleteNodeParams struct {

	/* Namespace.

	   target namespace
	*/
	Namespace string

	/* Node.

	   path to target node
	*/
	Node string

	/* Op.

	   the operation for the api

	   Default: "delete-node"
	*/
	Op string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the delete node params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteNodeParams) WithDefaults() *DeleteNodeParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the delete node params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *DeleteNodeParams) SetDefaults() {
	var (
		opDefault = string("delete-node")
	)

	val := DeleteNodeParams{
		Op: opDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the delete node params
func (o *DeleteNodeParams) WithTimeout(timeout time.Duration) *DeleteNodeParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the delete node params
func (o *DeleteNodeParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the delete node params
func (o *DeleteNodeParams) WithContext(ctx context.Context) *DeleteNodeParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the delete node params
func (o *DeleteNodeParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the delete node params
func (o *DeleteNodeParams) WithHTTPClient(client *http.Client) *DeleteNodeParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the delete node params
func (o *DeleteNodeParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithNamespace adds the namespace to the delete node params
func (o *DeleteNodeParams) WithNamespace(namespace string) *DeleteNodeParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the delete node params
func (o *DeleteNodeParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithNode adds the node to the delete node params
func (o *DeleteNodeParams) WithNode(node string) *DeleteNodeParams {
	o.SetNode(node)
	return o
}

// SetNode adds the node to the delete node params
func (o *DeleteNodeParams) SetNode(node string) {
	o.Node = node
}

// WithOp adds the op to the delete node params
func (o *DeleteNodeParams) WithOp(op string) *DeleteNodeParams {
	o.SetOp(op)
	return o
}

// SetOp adds the op to the delete node params
func (o *DeleteNodeParams) SetOp(op string) {
	o.Op = op
}

// WriteToRequest writes these params to a swagger request
func (o *DeleteNodeParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	// path param node
	if err := r.SetPathParam("node", o.Node); err != nil {
		return err
	}

	// query param op
	qrOp := o.Op
	qOp := qrOp
	if qOp != "" {

		if err := r.SetQueryParam("op", qOp); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
