// Code generated by go-swagger; DO NOT EDIT.

package variables

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetInstanceVariableParams creates a new GetInstanceVariableParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetInstanceVariableParams() *GetInstanceVariableParams {
	return &GetInstanceVariableParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetInstanceVariableParamsWithTimeout creates a new GetInstanceVariableParams object
// with the ability to set a timeout on a request.
func NewGetInstanceVariableParamsWithTimeout(timeout time.Duration) *GetInstanceVariableParams {
	return &GetInstanceVariableParams{
		timeout: timeout,
	}
}

// NewGetInstanceVariableParamsWithContext creates a new GetInstanceVariableParams object
// with the ability to set a context for a request.
func NewGetInstanceVariableParamsWithContext(ctx context.Context) *GetInstanceVariableParams {
	return &GetInstanceVariableParams{
		Context: ctx,
	}
}

// NewGetInstanceVariableParamsWithHTTPClient creates a new GetInstanceVariableParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetInstanceVariableParamsWithHTTPClient(client *http.Client) *GetInstanceVariableParams {
	return &GetInstanceVariableParams{
		HTTPClient: client,
	}
}

/* GetInstanceVariableParams contains all the parameters to send to the API endpoint
   for the get instance variable operation.

   Typically these are written to a http.Request.
*/
type GetInstanceVariableParams struct {

	/* Instance.

	   target instance
	*/
	Instance string

	/* Namespace.

	   target namespace
	*/
	Namespace string

	/* Variable.

	   target variable
	*/
	Variable string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get instance variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetInstanceVariableParams) WithDefaults() *GetInstanceVariableParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get instance variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetInstanceVariableParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get instance variable params
func (o *GetInstanceVariableParams) WithTimeout(timeout time.Duration) *GetInstanceVariableParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get instance variable params
func (o *GetInstanceVariableParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get instance variable params
func (o *GetInstanceVariableParams) WithContext(ctx context.Context) *GetInstanceVariableParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get instance variable params
func (o *GetInstanceVariableParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get instance variable params
func (o *GetInstanceVariableParams) WithHTTPClient(client *http.Client) *GetInstanceVariableParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get instance variable params
func (o *GetInstanceVariableParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInstance adds the instance to the get instance variable params
func (o *GetInstanceVariableParams) WithInstance(instance string) *GetInstanceVariableParams {
	o.SetInstance(instance)
	return o
}

// SetInstance adds the instance to the get instance variable params
func (o *GetInstanceVariableParams) SetInstance(instance string) {
	o.Instance = instance
}

// WithNamespace adds the namespace to the get instance variable params
func (o *GetInstanceVariableParams) WithNamespace(namespace string) *GetInstanceVariableParams {
	o.SetNamespace(namespace)
	return o
}

// SetNamespace adds the namespace to the get instance variable params
func (o *GetInstanceVariableParams) SetNamespace(namespace string) {
	o.Namespace = namespace
}

// WithVariable adds the variable to the get instance variable params
func (o *GetInstanceVariableParams) WithVariable(variable string) *GetInstanceVariableParams {
	o.SetVariable(variable)
	return o
}

// SetVariable adds the variable to the get instance variable params
func (o *GetInstanceVariableParams) SetVariable(variable string) {
	o.Variable = variable
}

// WriteToRequest writes these params to a swagger request
func (o *GetInstanceVariableParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param instance
	if err := r.SetPathParam("instance", o.Instance); err != nil {
		return err
	}

	// path param namespace
	if err := r.SetPathParam("namespace", o.Namespace); err != nil {
		return err
	}

	// path param variable
	if err := r.SetPathParam("variable", o.Variable); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
