// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/direktiv/direktiv/pkg/flow/ent/mirroractivity"
	"github.com/direktiv/direktiv/pkg/flow/ent/predicate"
)

// MirrorActivityDelete is the builder for deleting a MirrorActivity entity.
type MirrorActivityDelete struct {
	config
	hooks    []Hook
	mutation *MirrorActivityMutation
}

// Where appends a list predicates to the MirrorActivityDelete builder.
func (mad *MirrorActivityDelete) Where(ps ...predicate.MirrorActivity) *MirrorActivityDelete {
	mad.mutation.Where(ps...)
	return mad
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (mad *MirrorActivityDelete) Exec(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	if len(mad.hooks) == 0 {
		affected, err = mad.sqlExec(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*MirrorActivityMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			mad.mutation = mutation
			affected, err = mad.sqlExec(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(mad.hooks) - 1; i >= 0; i-- {
			if mad.hooks[i] == nil {
				return 0, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = mad.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, mad.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// ExecX is like Exec, but panics if an error occurs.
func (mad *MirrorActivityDelete) ExecX(ctx context.Context) int {
	n, err := mad.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (mad *MirrorActivityDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := &sqlgraph.DeleteSpec{
		Node: &sqlgraph.NodeSpec{
			Table: mirroractivity.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeUUID,
				Column: mirroractivity.FieldID,
			},
		},
	}
	if ps := mad.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	affected, err := sqlgraph.DeleteNodes(ctx, mad.driver, _spec)
	if err != nil && sqlgraph.IsConstraintError(err) {
		err = &ConstraintError{msg: err.Error(), wrap: err}
	}
	return affected, err
}

// MirrorActivityDeleteOne is the builder for deleting a single MirrorActivity entity.
type MirrorActivityDeleteOne struct {
	mad *MirrorActivityDelete
}

// Exec executes the deletion query.
func (mado *MirrorActivityDeleteOne) Exec(ctx context.Context) error {
	n, err := mado.mad.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{mirroractivity.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (mado *MirrorActivityDeleteOne) ExecX(ctx context.Context) {
	mado.mad.ExecX(ctx)
}
